﻿using System.Text;
using HeuristicLab.Common;
using HeuristicLab.Core;

namespace HeuristicLab.Clients.Hive.CloudManager.Model {
  public class StorageService : Item {
    public string Url { get; set; }
    public string ServiceName { get; set; }
    public StorageServiceProperties StorageServiceProperties { get; set; }

    public StorageService() {

    }

    public StorageService(StorageService original, Cloner cloner) {
      this.Url = original.Url;
      this.ServiceName = original.ServiceName;
      this.StorageServiceProperties = cloner.Clone(original.StorageServiceProperties);
    }

    public override string ToString() {
      StringBuilder sb = new StringBuilder();
      sb.AppendFormat("StorageService: Name={0}, Url={1}", ServiceName, Url);
      return sb.ToString();
    }

    public override int GetHashCode() {
      return base.GetHashCode();
    }

    public override bool Equals(object obj) {
      if (obj == null)
        return false;
      StorageService serv = obj as StorageService;
      if ((this.Url == serv.Url))
        return true;
      else
        return false;
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new StorageService(this, cloner);
    }
  }
}
